CSA/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('tasks/', views.task_list, name='task_list'),
    path('tasks/<int:task_id>/', views.task_detail, name='task_detail'),
    path('tasks/new/', views.task_create, name='task_create'),
    path('tasks/<int:task_id>/edit/', views.task_update, name='task_update'),
    path('tasks/<int:task_id>/delete/', views.task_delete, name='task_delete'),
]

TD_Django/urls.py
from django.contrib import admin
from django.urls import path, include  # assurez-vous d'importer 'include'

urlpatterns = [
    path('admin/', admin.site.urls),
    path('CSA/', include('CSA.urls')),  # Remplacez 'CSA.urls' par le chemin correct si votre application a un nom différent
    path('', include('CSA.urls')),  # Redirige l'URL racine vers les URLs de l'application CSA
    # Vous pouvez ajouter d'autres chemins ici
]

CSA/models.py
from django.db import models

class Task(models.Model):
    title = models.CharField(max_length=200)
    description = models.TextField(blank=True, null=True)
    completed = models.BooleanField(default=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)
    priority = models.IntegerField(default=0)

    def __str__(self):
        return self.title

CSA/forms.py
from django import forms
from .models import Task

class TaskForm(forms.ModelForm):
    class Meta:
        model = Task
        fields = ['title', 'description', 'completed', 'priority']

CSA/views.py
from django.shortcuts import render, get_object_or_404, redirect
from .models import Task
from .forms import TaskForm

def index(request):
    return render(request, 'CSA/index.html')

def task_list(request):
    tasks = Task.objects.all().order_by('priority')
    return render(request, 'CSA/task_list.html', {'tasks': tasks})

def task_detail(request, task_id):
    task = get_object_or_404(Task, id=task_id)
    return render(request, 'CSA/task_detail.html', {'task': task})

def task_create(request):
    if request.method == 'POST':
        form = TaskForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect('task_list')
    else:
        form = TaskForm()
    return render(request, 'CSA/task_form.html', {'form': form})

def task_update(request, task_id):
    task = get_object_or_404(Task, id=task_id)
    if request.method == 'POST':
        form = TaskForm(request.POST, instance=task)
        if form.is_valid():
            form.save()
            return redirect('task_list')
    else:
        form = TaskForm(instance=task)
    return render(request, 'CSA/task_form.html', {'form': form})

def task_delete(request, task_id):
    task = get_object_or_404(Task, id=task_id)
    if request.method == 'POST':
        task.delete()
        return redirect('task_list')
    return render(request, 'CSA/task_confirm_delete.html', {'task': task})

CSA/templates/CSA/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>ToDo Apps</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
            display: flex;
            justify-content: center;
            align-items: center;
            height: 100vh;
        }

        .container {
            text-align: center;
        }

        h1 {
            text-align: center;
            margin-top: 50px;
            color: #333;
        }

        .button {
            background-color: #4caf50;
            color: white;
            padding: 15px 30px;
            border: none;
            border-radius: 5px;
            text-transform: uppercase;
            font-weight: bold;
            text-decoration: none;
            transition: background-color 0.3s ease;
        }

        .button:hover {
            background-color: #45a049;
        }
    </style>
</head>
<body>
    <div class="container">
    <h1 id="welcome-text"></h1>
    <div style="margin-top: 20px;"> <!-- Ajout d'un espace avec une marge en haut -->
        <a href="{% url 'task_list' %}" class="button">Voir les tâches</a>
    </div>
</div>

<script>
        // Texte à afficher
        var text = "Bienvenue dans l'application de gestion des tâches";

        // Durée entre l'affichage de chaque lettre (en millisecondes)
        var speed = 100;

        // Index de la lettre actuelle
        var i = 0;

        function typeWriter() {
            if (i < text.length) {
                document.getElementById("welcome-text").innerHTML += text.charAt(i);
                i++;
                setTimeout(typeWriter, speed);
            }
        }

        // Démarrer l'animation d'écriture au chargement de la page
        window.onload = function () {
            typeWriter();
        };
    </script>
</body>
</html>

CSA/templates/CSA/task_confirm_delete.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Supprimer la tâche</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
        }

        .container {
            max-width: 600px;
            margin: 20px auto;
            padding: 20px;
            background-color: #fff;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        h1 {
            color: #333;
            text-align: center;
            margin-bottom: 20px;
        }

        button[type="submit"] {
            background-color: #dc3545;
            color: #fff;
            padding: 10px 20px;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }

        button[type="submit"]:hover {
            background-color: #c82333;
        }

        a {
            text-decoration: none;
            color: #007bff;
            display: block;
            text-align: center;
            margin-top: 20px;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>Êtes-vous sûr de vouloir supprimer "{{ task.title }}" ?</h1>
        <form method="post">
            {% csrf_token %}
            <button type="submit">Oui, supprimer cette tâche</button>
        </form>
        <a href="{% url 'task_detail' task.id %}">Non, retourner au détail de la tâche</a> |
        <a href="{% url 'task_list' %}">Retour à la liste des tâches</a>
    </div>
</body>
</html>

CSA/templates/CSA/task_create.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Créer une nouvelle tâche</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
        }

        .container {
            max-width: 600px;
            margin: 20px auto;
            padding: 20px;
            background-color: #fff;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        h1 {
            color: #333;
            text-align: center;
            margin-bottom: 20px;
        }

        form {
            display: flex;
            flex-direction: column;
        }

        label {
            font-weight: bold;
            margin-bottom: 5px;
        }

        input[type="text"] {
            padding: 10px;
            margin-bottom: 15px;
            border: 1px solid #ccc;
            border-radius: 5px;
            font-size: 16px;
        }

        button[type="submit"] {
            background-color: #007bff;
            color: #fff;
            padding: 10px 20px;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }

        button[type="submit"]:hover {
            background-color: #0056b3;
        }

        a {
            text-decoration: none;
            color: #007bff;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>Créer une nouvelle tâche</h1>
        <form method="post">
            {% csrf_token %}
            <label for="id_title">Titre:</label>
            {{ form.title }}
            <button type="submit">Créer la tâche</button>
        </form>
        <a href="{% url 'task_list' %}">Retour à la liste des tâches</a>
    </div>
</body>
</html>

CSA/templates/CSA/task_detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Détail de la tâche</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
        }

        .container {
            max-width: 600px;
            margin: 20px auto;
            padding: 20px;
            background-color: #fff;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        h1 {
            color: #333;
            text-align: center;
            margin-bottom: 20px;
        }

        p {
            margin-bottom: 10px;
        }

        a {
            text-decoration: none;
            color: #007bff;
        }

        .actions {
            text-align: center;
            margin-top: 20px;
        }

        .actions a {
            margin-right: 10px;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>{{ task.title }}</h1>
        <p>Description: {{ task.description }}</p>
        <p>Statut : {{ task.completed|yesno:"Terminée,Non Terminée" }}</p>
        <p>Créée le : {{ task.created_at }}</p>
        <p>Dernière mise à jour : {{ task.updated_at }}</p>
        <p>Priorité : {{ task.priority }}</p>
        <div class="actions">
            <a href="{% url 'task_update' task.id %}">Éditer cette tâche</a> |
            <a href="{% url 'task_delete' task.id %}">Supprimer cette tâche</a> |
            <a href="{% url 'task_list' %}">Retour à la liste des tâches</a>
        </div>
    </div>
</body>
</html>

CSA/templates/CSA/task_form.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>{% if form.instance.pk %}Modifier{% else %}Créer{% endif %} une tâche</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
        }

        .container {
            max-width: 600px;
            margin: 20px auto;
            padding: 20px;
            background-color: #fff;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        h1 {
            color: #333;
            text-align: center;
            margin-bottom: 20px;
        }

        form {
            display: flex;
            flex-direction: column;
        }

        label {
            font-weight: bold;
            margin-bottom: 5px;
        }

        input[type="text"] {
            padding: 10px;
            margin-bottom: 15px;
            border: 1px solid #ccc;
            border-radius: 5px;
            font-size: 16px;
        }

        button[type="submit"] {
            background-color: #007bff;
            color: #fff;
            padding: 10px 20px;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            transition: background-color 0.3s ease;
        }

        button[type="submit"]:hover {
            background-color: #0056b3;
        }

        a {
            text-decoration: none;
            color: #007bff;
            display: block;
            text-align: center;
            margin-top: 20px;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>{% if form.instance.pk %}Modifier la tâche: {{ form.instance.title }}{% else %}Créer une nouvelle tâche{% endif %}</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit">Sauvegarder</button>
        </form>
        <a href="{% url 'task_list' %}">Retour à la liste des tâches</a>
    </div>
</body>
</html>

CSA/templates/CSA/task_list.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Liste des Tâches</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            background-color: #f5f5f5;
            margin: 0;
            padding: 0;
        }

        .container {
            max-width: 800px;
            margin: 20px auto;
            padding: 20px;
            background-color: #fff;
            border-radius: 5px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }

        h1 {
            color: #333;
            text-align: center;
            margin-bottom: 20px;
        }

        a {
            text-decoration: none;
            color: #007bff;
        }

        .button {
            display: inline-block;
            background-color: #007bff;
            color: #fff;
            padding: 10px 20px;
            border-radius: 5px;
            text-decoration: none;
            transition: background-color 0.3s ease;
        }

        .button:hover {
            background-color: #0056b3;
        }

        ul {
            list-style-type: none;
            padding: 0;
        }

        li {
            margin-bottom: 10px;
            padding: 10px;
            background-color: #f9f9f9;
            border-radius: 5px;
        }

        .task-title {
            font-weight: bold;
            margin-bottom: 5px;
        }

        .task-status {
            color: #28a745;
        }

        .task-actions {
            display: inline-block;
            margin-left: 10px;
        }

        .task-actions a {
            margin-right: 5px;
        }
    </style>
</head>
<body>
    <div class="container">
        <h1>Liste des Tâches</h1>
        <a href="{% url 'task_create' %}" class="button">Créer une nouvelle tâche</a>
        <ul>
            {% for task in tasks %}
                <li>
                    <div class="task-title">{{ task.title }}</div>
                    <div class="task-status">Statut : {{ task.completed|yesno:"Terminée,Non Terminée" }}</div>
                    <div class="task-actions">
                        <a href="{% url 'task_detail' task.id %}">Détails</a>
                        <a href="{% url 'task_update' task.id %}">Éditer</a>
                        <a href="{% url 'task_delete' task.id %}">Supprimer</a>
                    </div>
                </li>
            {% empty %}
                <li>Aucune tâche disponible.</li>
            {% endfor %}
        </ul>
    </div>
</body>
</html>